﻿
// ---------------------------------------------------------------------------------
// 
// Sample code is copyright (c) Education Software Solutions Ltd 2021
// 
// Education Software Solutions (Hereafter 'ESS') provide sample code to 
// ESS Technical Integrators (Hereafter 'TIs') under consultancy 
// or as part of our TI programme to assist in the production of applications and services
// to benefit mutual customers.
// 
// Sample code is supplied by the ESS TI Team and may be augmented / changed at any time.
//
// ESS grants non exclusive rights to use the code on an 'as is' basis to contracted TIs 
// for the purpose of interfacing with ESS Products.  Code may be used in whole or in part 
// for the TIs products. Rights are subject to the restrictions below.
//
// This code may not be used for commercial purposes without a current TI agreement   
// in place with ESS.  The use of any sample code may incur liabilities for TI contractual 
// fees.  
//
// If the code is provided to eductational establishments for their own use then further 
// consent from ESS must be obtained before the code can be re-used for commercial gain.
//
// No warranty is provided . This header must be retained within the code and Copyright acknowleged as
// Parts (c) Education Software Solutions Ltd 2021 in version info.
//
// Code samples may be used to support other partners and no exclusivity is implied herein
//
// ---------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.Runtime.InteropServices;
using System.IO;


namespace SIMSReportingEngine
{
    class iniFile
    {
        [DllImport("kernel32")]
        private static extern int GetPrivateProfileString(string section, string key, string def, StringBuilder retVal, int size, string filePath);
        private static string _errorMessage = "";
        public static string ErrorMessage { get { return _errorMessage; } }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="_fileName">The name of the ini file</param>
        /// <param name="_section">The ini file Section</param>
        /// <param name="_key">The required key</param>
        /// <returns>Will return "" if it fails</returns>
        public static string Read(string _fileName, string _section, string _key)
        {
            StringBuilder rc = new StringBuilder();
            try
            {
                if (File.Exists(_fileName))
                {
                    GetPrivateProfileString(_section, _key, "", rc, 1024, _fileName);
                }
            }
            catch (Exception ex)
            {
                _errorMessage = ex.Message;
            }
            return rc.ToString();
        }
        
    }
}
